/*
 * General Settings
 */
var array_action = [];
array_action[0] = 'Denied'; //'Not opened';
array_action[1] = 'Accepted';   //'Opened';
array_action[2] = 'Accepted';   //'Granted';
array_action[3] = 'Denied';
array_action[100] = 'Denied';   //'Not opened';
array_action[101] = 'Accepted';   //'Opened';
array_action[102] = 'Accepted';   //'Granted';
array_action[103] = 'Denied';
array_action[200] = 'Denied';   //'Not opened';
array_action[201] = 'Accepted';   //'Opened';
array_action[202] = 'Accepted';   //'Granted';
array_action[203] = 'Denied';

var array_granted = [1, 2, 101, 102, 201, 202];
var array_denied = [0, 3, 100, 103, 200, 203];

var array_direction = [];
array_direction[0] = 'UNK';
array_direction[1] = 'UNK';
array_direction[2] = 'IN';
array_direction[3] = 'OUT';

var cloudSettings = {
    serverUrl: null,
    geoLat: null,
    geoLon: null,
    sensorProviderId: null,
    event_protocol: 0,
    event_new : true,
    event_update : false,
    event_lost : false,
    disableSendingImage: 0,
    enableSending: false
};

var a91xxSettings = {
    serverUrl: null,
    ipc_login: null,
    ipc_password: null,
    enableSending: false
};


var count_elminlist = 8;
var api_host = location.protocol + '//' + location.host + '/local/fflprapp/';
var api_eventsdb = '';
var is_events_hdr = false;
var is_search = false;
var lEvn = false;
var limit_data = 20;
var boxWidth = 400;
var last_timestamp = '';
var cameraGmtDiffSeconds = 0;
var loading_settings = 0;
var connecting_a1001 = 0;
var height_window = $(window).height();
if (height_window > 300) {
    height_window = height_window - 250;
}

var searchPagesTimestampTo = -1;
var ipcPasswordValid = 0;
// Variables for list validation
var platesValidator = /^\s*[0-9A-Za-z]{3,12}\s*$/;
var listLimit = 1000;
var warnings = {
    extraPlatesWhite: "There are more plates in white List \
     than it is allowed. Limit is " + listLimit,
    extraPlatesBlack: "There are more plates in black List \
     than it is allowed. Limit is " + listLimit,
    wrongBlack: "Incorrect plates in black list : ",
    wrongWhite: "Incorrect plates in white list : ",
    allowedSymbols: ". Allowed symbols are [0-9, A-Z, a-z], from 3 till 12 symbols",
    bothList: "Next plates are present in both lists : ",
    duplicates: "Next Plates is duplicated - "
};

/*
 * Canvas
 */
var canvas_width = 640;
var canvas_height = 360;
var canvas_f = this.__canvas = new fabric.Canvas('cf');
var cf_el = document.getElementById('cf').nextSibling;
var id_selected_prev = false;
canvas_f.setWidth(canvas_width);
canvas_f.setHeight(canvas_height);

var canvas_video = this.__canvas = new fabric.Canvas('videoCanvas');
canvas_video.setWidth(canvas_width);
canvas_video.setHeight(canvas_height);


var rect;
var rect2;
var direction_vector;

/*
 * Cached last valid ROI
 */
var savedRoi = {
    left: 0,
    top: 0,
    roi: 0,
    bottom: 0,
    width: 0,
    height: 0,
    angle: 0
};
var savedRoi2 = {
    left: 0,
    top: 0,
    roi: 0,
    bottom: 0,
    width: 0,
    height: 0,
    angle: 0
};
var savedDirection = {
    left: 0,
    top: 0,
    roi: 0,
    bottom: 0,
    width: 0,
    height: 0,
    angle: 0
};

var active_roi = 2;

/*
 * check rect to be in canvas
 *
 * @params {number} left,top, right, bottom new roi rect corners coordinates
 * @return {bool} return true if coordinates are valid
 */

function resize_video_full() {
    canvas_video.setWidth(320);
    canvas_video.setHeight(280);
}

function checkRoi(left, top, right, bottom) {
    if (left <= 0 || right <= 0 || top <= 0 || bottom <= 0)
        return false;
    if (left >= canvas_width || right >= canvas_width || top >= canvas_height || bottom >= canvas_height)
        return false;

// points of rect are (left,top) and (right, bottom)
    if (left >= right || top >= bottom)
        return false;

    var bound = rect.getBoundingRect();
    var bound2 = rect2.getBoundingRect();

    if (bound.left <= 0 || bound.right <= 0 || bound.top <= 0 || bound.bottom <= 0)
        return false;
    if (bound2.left <= 0 || bound2.right <= 0 || bound2.top <= 0 || bound2.bottom <= 0)
        return false;
    if (bound.left >= canvas_width || bound.width >= canvas_width || bound.top >= canvas_height || bound.height >= canvas_height)
        return false;
    if (bound2.left >= canvas_width || bound2.width >= canvas_width || bound2.top >= canvas_height || bound2.height >= canvas_height)
        return false;


    return true;
}

/*
 * Date Format
 */
var dateFormat = function () {
    var token = /d{1,4}|m{1,4}|yy(?:yy)?|([HhMsTt])\1?|[LloSZ]|"[^"]*"|'[^']*'/g,
        timezone = /\b(?:[PMCEA][SDP]T|(?:Pacific|Mountain|Central|Eastern|Atlantic) (?:Standard|Daylight|Prevailing) Time|(?:GMT|UTC)(?:[-+]\d{4})?)\b/g,
        timezoneClip = /[^-+\dA-Z]/g,
        pad = function (val, len) {
            val = String(val);
            len = len || 2;
            while (val.length < len) val = "0" + val;
            return val;
        };

    // Regexes and supporting functions are cached through closure
    return function (date, mask, utc) {
        var dF = dateFormat;

        // You can't provide utc if you skip other args (use the "UTC:" mask prefix)
        if (arguments.length == 1 && Object.prototype.toString.call(date) == "[object String]" && !/\d/.test(date)) {
            mask = date;
            date = undefined;
        }

        // Passing date through Date applies Date.parse, if necessary
        date = date ? new Date(date) : new Date;
        if (isNaN(date)) throw SyntaxError("invalid date");

        mask = String(dF.masks[mask] || mask || dF.masks["default"]);

        // Allow setting the utc argument via the mask
        if (mask.slice(0, 4) == "UTC:") {
            mask = mask.slice(4);
            utc = true;
        }

        var _ = utc ? "getUTC" : "get",
            d = date[_ + "Date"](),
            D = date[_ + "Day"](),
            m = date[_ + "Month"](),
            y = date[_ + "FullYear"](),
            H = date[_ + "Hours"](),
            M = date[_ + "Minutes"](),
            s = date[_ + "Seconds"](),
            L = date[_ + "Milliseconds"](),
            o = utc ? 0 : date.getTimezoneOffset(),
            flags = {
                d: d,
                dd: pad(d),
                ddd: dF.i18n.dayNames[D],
                dddd: dF.i18n.dayNames[D + 7],
                m: m + 1,
                mm: pad(m + 1),
                mmm: dF.i18n.monthNames[m],
                mmmm: dF.i18n.monthNames[m + 12],
                yy: String(y).slice(2),
                yyyy: y,
                h: H % 12 || 12,
                hh: pad(H % 12 || 12),
                H: H,
                HH: pad(H),
                M: M,
                MM: pad(M),
                s: s,
                ss: pad(s),
                l: pad(L, 3),
                L: pad(L > 99 ? Math.round(L / 10) : L),
                t: H < 12 ? "a" : "p",
                tt: H < 12 ? "am" : "pm",
                T: H < 12 ? "A" : "P",
                TT: H < 12 ? "AM" : "PM",
                Z: utc ? "UTC" : (String(date).match(timezone) || [""]).pop().replace(timezoneClip, ""),
                o: (o > 0 ? "-" : "+") + pad(Math.floor(Math.abs(o) / 60) * 100 + Math.abs(o) % 60, 4),
                S: ["th", "st", "nd", "rd"][d % 10 > 3 ? 0 : (d % 100 - d % 10 != 10) * d % 10]
            };

        return mask.replace(token, function ($0) {
            return $0 in flags ? flags[$0] : $0.slice(1, $0.length - 1);
        });
    };
}();

/*
 * Some common format strings
 */
dateFormat.masks = {
    "default": "ddd mmm dd yyyy HH:MM:ss",
    shortDate: "m/d/yy",
    mediumDate: "mmm d, yyyy",
    longDate: "mmmm d, yyyy",
    fullDate: "dddd, mmmm d, yyyy",
    shortTime: "h:MM TT",
    mediumTime: "h:MM:ss TT",
    longTime: "h:MM:ss TT Z",
    isoDate: "yyyy-mm-dd",
    isoTime: "HH:MM:ss",
    isoDateTime: "yyyy-mm-dd'T'HH:MM:ss",
    isoUtcDateTime: "UTC:yyyy-mm-dd'T'HH:MM:ss'Z'"
};

/*
 * Internationalization strings
 */
dateFormat.i18n = {
    dayNames: [
        "Sun", "Mon", "Tue", "Wed", "Thu", "Fri", "Sat",
        "Sunday", "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday"
    ],
    monthNames: [
        "Jan", "Feb", "Mar", "Apr", "May", "Jun", "Jul", "Aug", "Sep", "Oct", "Nov", "Dec",
        "January", "February", "March", "April", "May", "June", "July", "August", "September", "October", "November", "December"
    ]
};


/*
 * For convenience...
 */
Date.prototype.format = function (mask, utc) {
    return dateFormat(this, mask, utc);
};

/*
 * Set Cookie
 */
function setCookie(name, value, options) {
    options = options || {};

    var expires = options.expires;

    if (typeof expires == "number" && expires) {
        var d = new Date();
        d.setTime(d.getTime() + expires * 1000);
        expires = options.expires = d;
    }
    if (expires && expires.toUTCString) {
        options.expires = expires.toUTCString();
    }

    value = encodeURIComponent(value);

    var updatedCookie = name + "=" + value;

    for (var propName in options) {
        updatedCookie += "; " + propName;
        var propValue = options[propName];
        if (propValue !== true) {
            updatedCookie += "=" + propValue;
        }
    }

    document.cookie = updatedCookie;
}

function getTS(dateNow) {

    var pResult = new Date(dateNow / 1000).format("yyyy/mm/dd HH:MM:ss", true);
    dTime = new Date(pResult);
    var milliseconds = dTime.getTime() - (dTime.getTimezoneOffset() * 60000);
    var result = new Date(milliseconds).format("dd/mm/yyyy HH:MM:ss", true);

    return result;
}

/*
 * Get Cookie
 */
function getCookie(name) {
    var matches = document.cookie.match(new RegExp(
        "(?:^|; )" + name.replace(/([\.$?*|{}\(\)\[\]\\\/\+^])/g, '\\$1') + "=([^;]*)"
    ));
    return matches ? decodeURIComponent(matches[1]) : undefined;
}

/*
 * Show big image
 */
function showBigImg(el) {

    var targeted_popup_class = jQuery(el).attr('data-popup-open');
    var targeted_popup_img = jQuery(el).attr('data-popup-img');

    jQuery('#popup-context').html('<img src="' + targeted_popup_img + '" data-popup-close="popup-bigimg" onclick="closeBigImg(this)" alt="big img" />');

    $('[data-popup="' + targeted_popup_class + '"]').fadeIn(350);

    return false;

}

/*
 * Close big image
 */
function closeBigImg(el) {

    var targeted_popup_class = jQuery(el).attr('data-popup-close');
    $('[data-popup="' + targeted_popup_class + '"]').fadeOut(350);

    return false;

}

function ExtractCameraTimeOffset(allText) {
    $(allText).find("currentTimestampUs").each(function () {
        var gmtNow = new Date().getTime() / 1000;
        var cameraNow = parseInt($(this).text()) / 1000000;
        cameraGmtDiffSeconds = gmtNow - cameraNow;
        cameraGmtDiffSeconds = Math.round(cameraGmtDiffSeconds / 3600);
        cameraGmtDiffSeconds *= 3600;
        //console.log("GMT local : "+gmtNow+", GMT camera : "+cameraNow);
        //console.log("camera to GMT offset found : "+cameraGmtDiffSeconds+" seconds, "+ (cameraGmtDiffSeconds/3600) + " hours");
    })

}

/*
 * Pricess Events
 */
function processEvents(allText, event_action) {

    var r = new Array(), j = 0;

    ExtractCameraTimeOffset(allText);


    $(allText).find("event").each(function () {
        var ROI_BMP = $('ROI_BMP', this).text();
        var LPR = $('LPR_UTF8', this).text();
        var LP_BMP = $('LP_BMP', this).text();
        var ACTION = $('ACTION', this).text();
        var COUNTRY = $('COUNTRY', this).text();
        var RTIME = $('RTIME', this).text();
        var ACT_PARAM = $('ACT_PARAM', this).text().charAt(0);
        var TS = $('TS', this).text();
        var MOD_TS = $.trim($('MOD_TS', this).text()); //$('TS', this).text();
        var n = MOD_TS.lastIndexOf(" ");
        var ZONE = $('ROI_ID', this).text();
        var DIR = $('DIRECTION', this).text();
        MOD_TS = MOD_TS.substr(0, n);

        if (j == 0) {
            last_timestamp = TS;
        }

        r[++j] = '<tr ';
        if (ACTION < 0 || array_granted.indexOf(parseInt(ACTION)) < 0) {
            r[++j] = 'class="denied"';
        } else {
            r[++j] = 'class="accepted"';
        }
        r[++j] = '><td width="22%">';
        r[++j] = MOD_TS; //getTS(TS);
        r[++j] = '</td><td width="14%"><span>';
        r[++j] = LPR;
        r[++j] = '</span></td>';
        r[++j] = '<td width="6%">' + ZONE + '</td>';
        r[++j] = '<td width="10%">' + array_direction[DIR] + '</td>';
        r[++j] = '<td width="9%">' + RTIME + '</td>';
        r[++j] = '<td width="11%">';
        if (ACTION < 0) {
            r[++j] = 'Denied';  //'No opened';
        } else {
            r[++j] = array_action[ACTION];
        }
        var action_row = j;
        r[++j] = '</td><td width="19%"><a href="#" data-popup-open="popup-bigimg" data-popup-img="' + api_host + ROI_BMP + '" onclick="showBigImg(this)"><img src="' + api_host;
        r[++j] = LP_BMP;
        r[++j] = '" height="20" /></a><div style="display: none">' + api_host + LP_BMP + '</div></td>';

        r[++j] = '</tr>';

    });

    return r.join('');
}

/*
 * Get Last Event
 */
function getLastEvent(allText) {

    var r = new Array(), j = 0;


    ExtractCameraTimeOffset(allText);

    $(allText).find("event:first").each(function () {
        var ROI_BMP = $('ROI_BMP', this).text();
        var LPR = $('LPR_UTF8', this).text();
        var LP_BMP = $('LP_BMP', this).text();
        var ACTION = $('ACTION', this).text();
        var COUNTRY = $('COUNTRY', this).text();
        var RTIME = $('RTIME', this).text();
        var ACT_PARAM = $('ACT_PARAM', this).text().charAt(0);
        var TS = $('TS', this).text();
        var MOD_TS = $.trim($('MOD_TS', this).text()); //$('TS', this).text();
        var n = MOD_TS.lastIndexOf(" ");
        MOD_TS = MOD_TS.substr(0, n);


        if (j == 0) {
            last_timestamp = TS;
        }

        r[++j] = '<tr ';
        if (ACTION < 0 || array_granted.indexOf(parseInt(ACTION)) < 0) {
            r[++j] = 'class="denied"';
        } else {
            r[++j] = 'class="accepted"';
        }
        //Date / Time
        r[++j] = '><td width="26%">';
        r[++j] = MOD_TS;
        r[++j] = '</td>';
        //Time
        r[++j] = '<td width="12%">' + RTIME + '</td>';
        //Access
        r[++j] = '<td width="15%">';
        if (ACTION < 0) {
            r[++j] = 'Denied';  //'No opened';
        } else {
            r[++j] = array_action[ACTION];
        }
        r[++j] = '</td>';
        //Plate
        r[++j] = '<td width="15%"><span>';
        r[++j] = LPR;
        r[++j] = '</span></td>';
        var action_row = j;
        r[++j] = '<td width="20%"><a href="#" data-popup-open="popup-bigimg" data-popup-img="' + api_host + ROI_BMP + '" onclick="showBigImg(this)"><img src="' + api_host;
        r[++j] = LP_BMP;
        r[++j] = '" height="20" /></a><div style="display: none">' + api_host + LP_BMP + '</div></td>';

        r[++j] = '</tr>';

    });

    return r.join('');

}

/*
 * Load Events
 */
function loadEvents() {

    xml_time = 'limit=' + limit_data;

    $.ajax({
        type: 'GET',
        url: api_host + 'search.cgi',
        contentType: "text/xml",
        data: xml_time,
        success: function (data) {
            $('#last_result_table tbody').html(getLastEvent(data));
            $('#table-events tbody').html(processEvents(data));
            lEvn = true;
            return true;
        },
        error: function () {
            lEvn = true;
            return false;
        }
    });

    return false;

};

/*
 * Process search
 */
var lastSearch;
var lastSearchExist = false;

function processSearch(allText) {

    lastSearchExist = true;
    lastSearch = allText;
    var r = new Array(), j = 0;

    $(allText).find("event").each(function () {
        var ROI_BMP = $('ROI_BMP', this).text();
        var LPR = $('LPR_UTF8', this).text();
        var LP_BMP = $('LP_BMP', this).text();
        var ACTION = $('ACTION', this).text();
        var COUNTRY = $('COUNTRY', this).text();
        var RTIME = $('RTIME', this).text();
        var ACT_PARAM = $('ACT_PARAM', this).text().charAt(0);
        var TS = $('TS', this).text();
        if (searchPagesTimestampTo == -1) {
            searchPagesTimestampTo = TS;
        }
        var MOD_TS = $.trim($('MOD_TS', this).text()); //$('TS', this).text();
        var n = MOD_TS.lastIndexOf(" ");
        MOD_TS = MOD_TS.substr(0, n);

        r[++j] = '<tr ';
        if (ACTION < 0 || array_granted.indexOf(parseInt(ACTION)) < 0) {
            r[++j] = 'class="denied"';
        } else {
            r[++j] = 'class="accepted"';
        }
        r[++j] = '><td width="22%">';
        r[++j] = MOD_TS;
        r[++j] = '</td><td width="18%"><span>';
        r[++j] = LPR;
        r[++j] = '</span></td>';
        r[++j] = '<td width="14%">' + RTIME + '</td>';
        r[++j] = '<td width="15%">';
        if (ACTION < 0) {
            r[++j] = 'No action';
        } else {
            r[++j] = array_action[ACTION];
        }
        var action_row = j;
        r[++j] = '</td><td width="27%"><a href="#" data-popup-open="popup-bigimg" data-popup-img="' + api_host + ROI_BMP + '" onclick="showBigImg(this)"><img src="' + api_host;
        r[++j] = LP_BMP;
        r[++j] = '" height="20" /></a><div style="display: none">' + api_host + LP_BMP + '</div></td>';

        r[++j] = '</tr>';

    });

    return r.join('');
}

/*
 * Search Events
 */
var save_search_data;

function searchEvents() {

    var skip = 0, limit = 11;
    var search_data_all;

    var s_datetimefrom = toTimestampCameraSeconds($('#s_datetimefrom').val()) * 1000000,
        s_datetimeto = toTimestampCameraSeconds($('#s_datetimeto').val()) * 1000000,
        s_plate = $('#s_plate').val(),
        s_action = $('#s_action').val(),
        s_country = "",
        s_skip = $('#number_page').val(),
        search_data;


    if (searchPagesTimestampTo != -1) {
        s_datetimeto = parseInt(searchPagesTimestampTo) + 1000;
    }

    skip = limit * (s_skip - 1);

    search_data_all = 'timestampfrom=' + s_datetimefrom + '&timestampto=' + s_datetimeto + '&text=' + s_plate + '&action=' + s_action + '&country=' + s_country;
    search_data = search_data_all + '&limit=' + limit + '&offset=' + skip;
    save_search_data = search_data_all + '&limit=-1';
    $.ajax({
        type: 'GET',
        url: api_host + 'search.cgi',
        contentType: "text/xml",
        data: search_data,
        success: function (data) {

            $('#search_table tbody').html(processSearch(data));


            if ($('#search_table tbody tr').length > 0) {
                $('.search-navigation').css('display', 'block');
            } else {
                $('#search_table tbody').html('<h4>You haven’t searched for anything yet!</h4>');
            }

        }
    });

};

/*
 * Search Events
 */
function exportEvents() {

    var skip = 0, limit = 11;

    var s_datetimefrom = toTimestampCameraSeconds($('#s_datetimefrom').val()) * 1000000,
        s_datetimeto = toTimestampCameraSeconds($('#s_datetimeto').val()) * 1000000,
        s_plate = $('#s_plate').val(),
        s_action = $('#s_action').val(),
        s_country = $('#s_country').val(),
        s_skip = $('#number_page').val(),
        search_data;

    if (searchPagesTimestampTo != -1) {
        s_datetimeto = parseInt(searchPagesTimestampTo) + 1000;
    }

    skip = limit * (s_skip - 1);

    search_data = 'timestampfrom=' + s_datetimefrom + '&timestampto=' + s_datetimeto + '&text=' + s_plate + '&action=' + s_action + '&country=' + s_country + '&limit=' + limit + '&offset=' + skip;

    $.ajax({
        type: 'GET',
        url: api_host + 'search.cgi',
        contentType: "text/xml",
        data: search_data,
        success: function (data) {

            $('#search_table tbody').html(processSearch(data));

        }
    });

};

$('#search_nav_prev').on('click', function () {

    var np = $('#number_page');
    if (np.val() > 1) {
        np.val(parseInt(np.val()) - 1);
    }
    searchEvents();

});

$('#search_nav_next').on('click', function () {

    var np = $('#number_page');
    np.val(parseInt(np.val()) + 1);
    searchEvents();

});


function showSettings() {
    if (loading_settings == 3) {
        $('#settings_status').fadeOut();
        $('#form_settings').fadeIn(300);
    }
}

function hideSettings() {
    $('#settings_status').show();
    $('#form_settings').hide();
    hideROI();

}

function showSaveStatus() {
    $('#save_camera_settings').show();
}

function hideSaveStatus() {
    $('#save_camera_settings').fadeOut();
}

function hideLoadCameraListStatus() {
    $('#load_camera_list').fadeOut();
}
function showSyncCameraStatus() {
    $('#sync_camera_bwlist').show();
}
function hideSyncCameraStatus() {
    $('#sync_camera_bwlist').fadeOut();
}

/*
 * Show video from camera
 */
function videoCamera() {

    var timenow = new Date();
    var camera = 1;
    var resolution = canvas_width + 'x' + canvas_height;
    var audio = 0;
    var fps = '5';
    var overview = 1;
    var el_forimg = document.getElementById("playerImg");
    var imgsrc = "/axis-cgi/mjpg/video.cgi?camera=" + camera + "&resolution=" + resolution + "&audio=" + audio + "&fps=" + fps + "&overview=" + overview;

    el_forimg.setAttribute('src', imgsrc);

}

function setMaxMinPlateVal(roi) {

}

$('#sd_detailed_btn').on('click', function () {

    if ($('#sd_detailed_btn').html().includes('˅')) {
        $('#sd_detailed_data').show();
        $('#sd_detailed_btn').html('˄');
    } else {
        $('#sd_detailed_data').hide();
        $('#sd_detailed_btn').html('˅');
    }

});

function setCardStatus(sdCardStatus) {

    $('.sd_status').hide();
    if (sdCardStatus == 1) {
        $('#sd_inserted').show();
        $('.sd_detailed').hide();
        $('#sdTotalSpace').html('inserted');
        //document.getElementById("sdCardStatus").innerHTML = 'INSERTED';
/*
        $.ajax({
            type: 'GET',
            dataType: 'text',
            url: api_host + "sd_status.cgi",
            success: function (data) {
                var jsonData = $.parseJSON(data);
                var total = '(' + (jsonData.TotalSpaceSize/1e6).toFixed(2)+'GB'+ ')';
                var free = jsonData.TotalSpaceSize > 0 ? 100 * jsonData.FreeSpaceSize / jsonData.TotalSpaceSize : 0;
                var status = jsonData.CardStatus;
                var system = jsonData.CardFileSystem;
                var encrypted = jsonData.Encrypted>0?'Yes':'No';

                $('#sdTotalSpace').html(total);
                $('#sdFreeSpace').html(free + '%');
                $('#sdCardStatus').html(status);
                $('#sdCardFileSystem').html(system);
                $('#sdEncrypted').html(encrypted);

                $('#sd_detailed_btn').html('˅');
                $('#sd_detailed_btn').show();
            },
            error: function (data) {
                console.log('Loading SD card status failed');
            }
        });
*/
    } else {
        $('#sd_not_inserted').show();
        //document.getElementById("sdCardStatus").innerHTML = 'Insert SD card'; //'NOT INSERTED';
    }

}

/*
 * Load Config
 */
function loadConfig() {
    $.ajax({
        url: api_host + 'config.cgi',
        success: function (data) {
            width = data.getElementsByTagName("resolution")[0].getElementsByTagName("width")[0].childNodes[0].nodeValue;
            height = data.getElementsByTagName("resolution")[0].getElementsByTagName("height")[0].childNodes[0].nodeValue;

            fk = data.getElementsByTagName("resolution")[0].getElementsByTagName("fk")[0].childNodes[0].nodeValue;

            if (fk == 0) {
                var selectListRes = '<select name=\"camera_resolution\" id=\"camera_resolution\" class=\"select_field\">';
                selectListRes += '<option value=\"1\">1920x1080</option>';
                selectListRes += '</select>';
                $('#camera_resolution').html(selectListRes);
            }

            var top = data.getElementsByTagName("top")[0].childNodes[0].nodeValue;
            var left = data.getElementsByTagName("left")[0].childNodes[0].nodeValue;
            var bottom = data.getElementsByTagName("bottom")[0].childNodes[0].nodeValue;
            var right = data.getElementsByTagName("right")[0].childNodes[0].nodeValue;

            var roi_width = data.getElementsByTagName("width")[0].childNodes[0].nodeValue;
            var roi_height = data.getElementsByTagName("height")[0].childNodes[0].nodeValue;
            var roi_angle = data.getElementsByTagName("roi")[0].getElementsByTagName("angle")[0].childNodes[0].nodeValue;


            savedRoi.top = Math.round(parseFloat(top / 1000) * canvas_height);
            savedRoi.left = Math.round(parseFloat(left / 1000) * canvas_width);
            savedRoi.bottom = Math.round(parseFloat(bottom / 1000) * canvas_height);
            savedRoi.right = Math.round(parseFloat(right / 1000) * canvas_width);

            savedRoi.width = Math.round(parseFloat(roi_width / 1000) * canvas_width);
            savedRoi.height = Math.round(parseFloat(roi_height / 1000) * canvas_height);
            savedRoi.angle = Math.round(parseFloat(roi_angle / 1000));

            var top2 = data.getElementsByTagName("roitwo")[0].getElementsByTagName("top")[0].childNodes[0].nodeValue;
            var left2 = data.getElementsByTagName("roitwo")[0].getElementsByTagName("left")[0].childNodes[0].nodeValue;
            var roi_width2 = data.getElementsByTagName("roitwo")[0].getElementsByTagName("width")[0].childNodes[0].nodeValue;
            var roi_height2 = data.getElementsByTagName("roitwo")[0].getElementsByTagName("height")[0].childNodes[0].nodeValue;
            var roi_angle2 = data.getElementsByTagName("roitwo")[0].getElementsByTagName("angle")[0].childNodes[0].nodeValue;

            active_roi = data.getElementsByTagName("active_roi")[0].childNodes[0].nodeValue;
            $('#roi_count').val(active_roi);

            var use_case = data.getElementsByTagName("lprUseCase")[0].childNodes[0].nodeValue;
            $('#region_list').val(use_case);

            savedRoi2.top = Math.round(parseFloat(top2 / 1000) * canvas_height);
            savedRoi2.left = Math.round(parseFloat(left2 / 1000) * canvas_width);

            savedRoi2.width = Math.round(parseFloat(roi_width2 / 1000) * canvas_width);
            savedRoi2.height = Math.round(parseFloat(roi_height2 / 1000) * canvas_height);
            savedRoi2.angle = Math.round(parseFloat(roi_angle2 / 1000));


            var direction_angle = data.getElementsByTagName("direction")[0].getElementsByTagName("angle")[0].childNodes[0].nodeValue;

            var roi = [];
            roi['left'] = savedRoi.left;
            roi['right'] = savedRoi.right;
            roi['top'] = savedRoi.top;
            roi['bottom'] = savedRoi.bottom;
            roi['r_width'] = width;
            roi['r_height'] = height;

            roi['width'] = savedRoi.width;
            roi['height'] = savedRoi.height;
            roi['angle'] = savedRoi.angle;

            showROI(roi);

            var roi2 = [];
            roi2['left'] = savedRoi2.left;
            roi2['top'] = savedRoi2.top;
            roi2['r_width'] = width;
            roi2['r_height'] = height;

            roi2['width'] = savedRoi2.width;
            roi2['height'] = savedRoi2.height;
            roi2['angle'] = savedRoi2.angle;

            savedDirection.angle = Math.round(parseFloat(direction_angle / 1000));

            showROI2(roi2);

            var sdCardStatus = data.getElementsByTagName("sdCardStatus")[0].childNodes[0].nodeValue;
            setCardStatus(sdCardStatus);

            var storedEvents = data.getElementsByTagName("stored_events")[0].childNodes[0].nodeValue;
            document.getElementById("storedEvents").innerHTML = storedEvents;

            var barrier_mode = data.getElementsByTagName("barrier_mode")[0].childNodes[0].nodeValue;
            var barrier_priority = data.getElementsByTagName("barrier_priority")[0].childNodes[0].nodeValue;
            var barrier_vehicle_direction = data.getElementsByTagName("barrier_vehicle_direction")[0].childNodes[0].nodeValue;
            var plate_min_size_percent = data.getElementsByTagName("plate_min_size_percent")[0].childNodes[0].nodeValue;
            var plate_min_size = data.getElementsByTagName("plate_min_size")[0].childNodes[0].nodeValue;
            var plate_max_size = data.getElementsByTagName("plate_max_size")[0].childNodes[0].nodeValue;

            var ipcLogin = data.getElementsByTagName("ipc_login")[0].childNodes[0].nodeValue;
            var ipcPassword = data.getElementsByTagName("ipc_password")[0].childNodes[0].nodeValue;
            ipcPasswordValid = data.getElementsByTagName("ipc_password_valid")[0].childNodes[0].nodeValue;
            var relayPort = data.getElementsByTagName("relay_port")[0].childNodes[0].nodeValue;
            var relayType = data.getElementsByTagName("relay_type")[0].childNodes[0].nodeValue;

            var frame_rotate = data.getElementsByTagName("frame_rotate")[0].childNodes[0].nodeValue;
            var full_frame = data.getElementsByTagName("full_frame")[0].childNodes[0].nodeValue;
            var full_frame_downscale = data.getElementsByTagName("full_frame_downscale")[0].childNodes[0].nodeValue;

            var bw_strict = data.getElementsByTagName("bw_strict")[0].childNodes[0].nodeValue;
            var threshold = data.getElementsByTagName("threshold")[0].childNodes[0].nodeValue;
            var bw_ldist = data.getElementsByTagName("bw_ldist")[0].childNodes[0].nodeValue;

            var lpr_text_overlay = data.getElementsByTagName("lpr_text_overlay")[0].childNodes[0].nodeValue;

            if (full_frame > 0)
                $('#full_frame').prop('checked', true);

            if (bw_strict == 1)
                $('#bw_list_strict').prop('checked', true);

            if (lpr_text_overlay == 1)
                $('#lpr_text_overlay').prop('checked', true);

            $('#threshold').val(parseFloat(threshold));
            $('#bw_list_ldist').val(bw_ldist);

            $('#frame_rotate').val(frame_rotate);

            $('#ipc_login').val(ipcLogin);
            $('#ipc_pwd').val(ipcPassword);
            $('#io_output').val(relayPort);
            $('#relay_type').val(relayType);

            $('#barrier_mode').val(barrier_mode);
            $('#barrier_priority').val(barrier_priority);
            $('#barrier_vehicle_direction').val(barrier_vehicle_direction);

            $('#min_size_plate').val(plate_min_size);
            $('#max_size_plate').val(plate_max_size);

            $('#sizeOutputId').val(plate_min_size_percent);
            if (width == "3072")
                $('#camera_resolution').val("3");
            if (width == "1280")
                $('#camera_resolution').val("2");

            var keep_events = data.getElementsByTagName("keep_events")[0].childNodes[0].nodeValue;
            $('#keep_events').val(keep_events);
            var keep_events_period = data.getElementsByTagName("keep_events_period")[0].childNodes[0].nodeValue;
            $('#keep_events_period').val(keep_events_period);

            loading_settings++;
            showSettings();
            if (ipcPasswordValid == 0)
               alert("Config contains incorrect password for camera.Please update configuration with correct password!");
        },
        error: function (data) {

        }
    });
};

/*
 * Check if there are no duplicates in list
 * 
 * @param {Array} listArr - array that contains list numbers
 * @return {Array} array of duplicates or empty arr;
 */
function findDuplicates(listArr) {
    var uniqueList = {};
    var duplicates = [];

    for (var i = 0; i < listArr.length; i++) {
        if (listArr[i] in uniqueList) {
            listArr.splice(i, 1);
            i--;
        }
        else
            uniqueList[listArr[i]] = true;
    }

    return listArr;
}

/*
 * Check if list plates in list and its size is valid
 *       and delete 
 *
 * @param {Array} listArr - array of plates
 * @param {number} maxSize - limit of plates in list
 * @return {bool} true if listArr length is more than maxSize allowed
 */

function checkListSizeAndClean(listArr, maxSize) {
    for (var i = 0; i < listArr.length; i++) {
        if (listArr[i] == "") {
            listArr.splice(i, 1);
            i--;
        }
        if (i >= maxSize) {
            listArr.splice(i, listArr.length - i);
        }
    }
    return listArr;
}


/*
 * Check if list plates in list and its size is valid;
 *
 * @param {Array} listArr - array of plates
 * @param {regexp} validator - template for correct plates
 * @return {Array} array of wrong plates;
 */

function validateList(listArr, validator) {
    return listArr;
}


function listIntersection(blackListArr, whiteListArr) {
    var temp = {};
    var intersection = [];

    for (var i = 0; i < whiteListArr.length; i++)
        temp[whiteListArr[i]] = true;

    for (var i = 0; i < blackListArr.length; i++)
        if (blackListArr[i] in temp) {
            blackListArr.splice(i, 1)
            i--;
        }
    return blackListArr, whiteListArr
}

/*
 * Close popup window
 */
$('.close').click(function () {
    $('#list_warning').css('display', 'none');
    $('#list_warning .modal-body').text("");
});

$('.btn-ok').click(function () {
    $('#list_warning').css('display', 'none');
    $('#list_warning .modal-body').text("");
});

/*
 * Show modal window with warning
 *
 * @param {string} message to show in warning
 * @retutn nothing
 */

function displayWarning(message) {
    $('#list_warning .modal-body').text(message);
    $('#list_warning').css('display', 'block');
}


function checkBWList(arr_bl, arr_wl) {
    arr_bl = checkListSizeAndClean(arr_bl, listLimit)
    arr_wl = checkListSizeAndClean(arr_wl, listLimit)
    arr_bl = validateList(arr_bl, platesValidator);
    arr_wl = validateList(arr_wl, platesValidator);
    arr_bl = findDuplicates(arr_bl);
    arr_wl = findDuplicates(arr_wl);
    arr_bl, arr_wl = listIntersection(arr_bl, arr_wl);
    return arr_bl, arr_wl;
}

function resetToDefault() {
    if (!confirm('Are you sure you want to reset settings to default values ?')) {
        return false;
    }


}

$('#clr_settings_button').click(function () {
    resetToDefault();
    return false;
});

function displayAdvSettings() {
    $('#adv-settigs').css('display', 'block');
}

function displayRemoteCameraSettings() {
    $('#camera-settigs').css('display', 'block');
     ListCameras()
}

$('.closeadv').click(function () {
    closeAdvSettings();
});

function closeAdvSettings() {
    $('#adv-settigs').css('display', 'none');
}

$('.closecameraadv').click(function () {
    closeCameraSettings();
});

function closeCameraSettings() {
    $('#camera-settigs').css('display', 'none');
    clearInterval(refreshCamerasStatusID);
    hideSyncCameraStatus();
}

function saveAdvConfig(data) {
    closeAdvSettings();
    saveConfig(data);
}
function DoneCameraConfig(data){
    closeCameraSettings();
}

function DeleteCamera(camera_id){
   console.log("Camera Deleting:"+camera_id);

    var request = "?api=delcamera&camera_id="+camera_id;
    $.ajax({
        type: 'GET',
        url: api_host + "api.cgi"+request,
        contentType: "text/xml",
        dataType:"json",
        processData: false,
        success: function (data) {
            //ShowCameras(data);
            $('#camera_table tbody').html(ShowCameras(data));
            CreateSyncCamerasList(data);
        }
    });

}
function ShowCameras(data) {
   console.log("Cameras Show");
    var r = new Array(), j = 0;

    //table header
    r[++j] ='<tr>';
        r[++j] = '<td size=\"40\"><B>' + 'Camera IP' + '</B></td>';
        r[++j] = '<td size=\"40\"><B>' + 'user' + '</B></td>';
        r[++j] = '<td size=\"40\"><B>' + 'password' + '</B></td>';
        r[++j] = '<td><B>' + 'Last Sync'+ '</B></td>';
        r[++j] = '<td>' +  '</td>';
    r[++j] ='</tr>';

    for (var i = 0, len = data.cameras.length; i < len; i++) {
        var camera_id = data.cameras[i].camera_id;
        var camera_ip = data.cameras[i].camera_ip;
        var camera_login = data.cameras[i].camera_login;
        //var camera_password = data.cameras[i].camera_password;
        var camera_password = '****';
        var camera_sync = data.cameras[i].camera_sync;

        r[++j] = '<tr><td>' + camera_ip + '</td>';
        r[++j] = '<td>' + camera_login + '</td>';
        r[++j] = '<td>' + camera_password + '</td>';
        if (camera_sync){
            r[++j] = '<td>' +camera_sync+  '</td>';
        }
        else
            r[++j] = '<td>' +'-' + '</td>';

        r[++j] = '<td><div class="submit-form-small" onclick="DeleteCamera(\'' + camera_id + '\')">Delete</div></td>';
        r[++j] = '</tr>';
    }


r[++j] = '<tr>';
r[++j] = '<td>';
r[++j] = '<input type=\"text\" value=\"\" name=\"camera_ip\"   id=\"camera_ip\" class=\"input_field_small\">';
r[++j] = '</td>';
r[++j] = '<td>';
r[++j] = '<input type=\"text\" value=\"\" name=\"camera_login\"  id=\"camera_login\" class=\"input_field\" >';
r[++j] = '</td>';
r[++j] = '<td>';
r[++j] = '<input type=\"password\" value=\"\" name=\"camera_password\" id=\"camera_password\" class=\"input_field\" >';
r[++j] = '</td>';
r[++j] = '<td></td>';
//r[++j] = '		</td>';
r[++j] = '<td></td>';
//r[++j] = '		</td>';
r[++j] = '</tr>';


/*
r[++j] = '<tr>';
r[++j] = '<td>';
r[++j] = '<input type=\"text\" value=\"\" name=\"camera_ip\"   id=\"camera_ip\" class=\"input_field_small\" style=\"width: 16\">';
r[++j] = '</td>';
r[++j] = '<td>';
r[++j] = '<input type=\"text\" value=\"\" name=\"camera_login\"  id=\"camera_login\" class=\"input_field\" style=\"width: 16\">';
r[++j] = '</td>';
r[++j] = '<td>';

r[++j] = '<input type=\"password\" value=\"\" name=\"camera_password\" id=\"camera_password\" class=\"input_field\" style=\"width: 16\">';
r[++j] = '</td>';
r[++j] = '<td></td>';
//r[++j] = '		</td>';
r[++j] = '<td></td>';
//r[++j] = '		</td>';
r[++j] = '</tr>';
*/
    return r.join('');
}
function AddCamera(data) {

    var camera_ip = $(data.camera_ip).val();
    var camera_login = $(data.camera_login).val();
    var camera_password = $(data.camera_password).val();
    var request = "?api=addcamera&camera_ip="+camera_ip+"&camera_login="+camera_login+"&camera_password="+camera_password;
    $.ajax({
        type: 'GET',
        url: api_host + "api.cgi"+request,
        contentType: "text/xml",
        dataType:"json",
        processData: false,
        success: function (data) {
            //ShowCameras(data);
            $('#camera_table tbody').html(ShowCameras(data));
            CreateSyncCamerasList(data);
        }
    });

}
var refreshCamerasStatusID = -1;
function ListCameras() {

    var request = "?api=listcamera";
    $.ajax({
        type: 'GET',
        url: api_host + "api.cgi"+request,
        contentType: "text/xml",
        dataType:"json",
        processData: false,
        success: function (data) {
            $('#camera_table tbody').html(ShowCameras(data));
            hideLoadCameraListStatus();
            CreateSyncCamerasList(data);
        }
    });

}
//120 sec
var max_sync_timeout = 1000*60*2;
var current_sync_time =0;
var sync_check_interval = 3000;

function ListSyncCameras() {

    var request = "?api=listcamera";
    $.ajax({
        type: 'GET',
        url: api_host + "api.cgi"+request,
        contentType: "text/xml",
        dataType:"json",
        processData: false,
        success: function (data) {
            $('#camera_table tbody').html(ShowCameras(data));
            //hideLoadCameraListStatus();
            if (CheckSyncCamerasStatus(data) == false){
                setTimeout(ListSyncCameras, sync_check_interval);
            }
        }
    });

}


var cameraList = [];

var cameraClass = function (id, ip, last_sync) {

    this.id = id;
    this.ip = ip;
    this.last_sync = last_sync;

}
function CreateSyncCamerasList(data) {
    console.log("Cameras Sync List");

    cameraList = [];

    for (var i = 0, len = data.cameras.length; i < len; i++) {
        var camera_id = data.cameras[i].camera_id;
        var camera_ip = data.cameras[i].camera_ip;
        var camera_login = data.cameras[i].camera_login;
        var camera_password = '****';
        var camera_sync = data.cameras[i].camera_sync;

        var cameraListItem = new cameraClass(camera_id, camera_ip, camera_sync);
            cameraList.push(cameraListItem);

    }
}

function CheckSyncCamerasStatus(data) {

    var not_synced_count = 0;

    for (var i = 0, len = data.cameras.length; i < len; i++) {
        if (data.cameras[i].camera_sync == cameraList[i].last_sync){
            not_synced_count++;
        }
    }

    console.log("Wait for sync "+not_synced_count+" cameras, out  "+current_sync_time/1000 +" of "+ max_sync_timeout/1000 +" sec");

    current_sync_time = current_sync_time + sync_check_interval;

    if (current_sync_time > max_sync_timeout){
        //sync timed out
        console.log("Sync timed out, "+not_synced_count+" devices fails");
        hideSyncCameraStatus();
        clearInterval(refreshCamerasStatusID);
        alert("Synchronization failed for some devices.Please check your configuration!");
        return true;
    }

    if (not_synced_count > 0){
       return false;
    }

    hideSyncCameraStatus();
    clearInterval(refreshCamerasStatusID);
    return true;
}

function SyncCameraList() {

    if (ipcPasswordValid == 0){
         alert("Config contains incorrect password for camera.Please update configuration with correct password!");
         return false;
    }

    if (cameraList.length == 0){
         alert("Please, add cameras first!");
         return false;
    }

    showSyncCameraStatus();
    current_sync_time =0;

    var request = "?api=synccameralists";
    $.ajax({
        type: 'GET',
        url: api_host + "api.cgi"+request,
        contentType: "text/xml",
        dataType:"json",
        processData: false,
        success: function (data) {
            $('#camera_table tbody').html(ShowCameras(data));
                CreateSyncCamerasList(data);
                refreshCamerasStatusID = setTimeout(function(){
                ListSyncCameras();
                },sync_check_interval);
        }
    });

}



$('#bw_list_strict').change(function () {
    $('#bw_list_ldist').prop('disabled', $('#bw_list_strict').prop('checked'));
});

function handleInput(input) {
    var min = parseFloat(input.getAttribute("min"));
    var max = parseFloat(input.getAttribute("max"));
    var def = parseFloat(input.getAttribute("default"));
    var val = parseFloat(parseFloat(input.value).toFixed(2));
    if (val < min) {
        input.value = min;
    } else if (val > max) {
        input.value = max;
    } else {
        input.value = val||def||min||max;
    }
    input.setCustomValidity("");
}

function validateInput(input) {
    var min = parseFloat(input.getAttribute("min"));
    var max = parseFloat(input.getAttribute("max"));
    var val = parseFloat(input.value);
    if (val < min || val > max || isNaN(val)) {
        input.setCustomValidity("Value must be in range "+min+" - "+max);
    } else {
        input.setCustomValidity("");
    }
}
var savedConfig = 0;
/*
 * Save Config
 */
function saveConfig(data) {

    savedConfig = 0;

    var left = rect.getLeft();
    var right = left + rect.getWidth();
    var top = rect.getTop();
    var bottom = top + rect.getHeight();

    var width = 0;
    var height = 0;

    var roi_width = rect.getWidth();
    var roi_height = rect.getHeight();
    var roi_angle = rect.getAngle();

    var left2 = rect2.getLeft();
    var right2 = left2 + rect2.getWidth();
    var top2 = rect2.getTop();
    var bottom2 = top2 + rect2.getHeight();

    var roi_width2 = rect2.getWidth();
    var roi_height2 = rect2.getHeight();
    var roi_angle2 = rect2.getAngle();

    if (checkRoi(left, top, right, bottom)) {
        savedRoi.left = left;
        savedRoi.top = top;
        savedRoi.right = right;
        savedRoi.bottom = bottom;

        savedRoi.width = roi_width;
        savedRoi.height = roi_height;
        savedRoi.angle = roi_angle;
    } else {
        showROI(savedRoi);

        left = savedRoi.left;
        top = savedRoi.top;
        rigth = savedRoi.right;
        bottom = savedRoi.bottom;
        roi_width = savedRoi.width;
        roi_height = savedRoi.height;
        roi_angle = savedRoi.angle;
    }

    if (checkRoi(left2, top2, right2, bottom2)) {
        savedRoi2.left = left2;
        savedRoi2.top = top2;
        savedRoi2.right = right2;
        savedRoi2.bottom = bottom2;

        savedRoi2.width = roi_width2;
        savedRoi2.height = roi_height2;
        savedRoi2.angle = roi_angle2;
    } else {
        showROI2(savedRoi2);

        left2 = savedRoi2.left;
        top2 = savedRoi2.top;
        rigth2 = savedRoi2.right;
        bottom2 = savedRoi2.bottom;
        roi_width2 = savedRoi2.width;
        roi_height2 = savedRoi2.height;
        roi_angle2 = savedRoi2.angle;
    }

    width = 1920;
    height = 1080;
    camera_resolution = $(data.camera_resolution).val();
    if (camera_resolution == 3) {
        width = 3072;
        height = 1728;
    }
    if (camera_resolution == 2) {
        width = 1280;
        height = 720;
    }


    left = Math.floor(left / canvas_width * 1000);    //Math.round( left / (canvas_width/width) );
    right = Math.floor(right / canvas_width * 1000);   //Math.round( right / (canvas_width/width) );
    top = Math.floor(top / canvas_height * 1000);    //Math.round( top / (canvas_height/height) );
    bottom = Math.floor(bottom / canvas_height * 1000); //Math.round( bottom / (canvas_height/height) );

    roi_width = Math.floor(roi_width / canvas_width * 1000);
    roi_height = Math.floor(roi_height / canvas_height * 1000);
    roi_angle = Math.floor(roi_angle * 1000);


    left2 = Math.floor(left2 / canvas_width * 1000);    //Math.round( left / (canvas_width/width) );
    right2 = Math.floor(right2 / canvas_width * 1000);   //Math.round( right / (canvas_width/width) );
    top2 = Math.floor(top2 / canvas_height * 1000);    //Math.round( top / (canvas_height/height) );
    bottom2 = Math.floor(bottom2 / canvas_height * 1000); //Math.round( bottom / (canvas_height/height) );

    roi_width2 = Math.floor(roi_width2 / canvas_width * 1000);
    roi_height2 = Math.floor(roi_height2 / canvas_height * 1000);
    roi_angle2 = Math.floor(roi_angle2 * 1000);

    active_roi = $('#roi_count').val();

    var use_case = $('#region_list').val();

    var full_frame = 0;
    if ($('#full_frame').prop('checked'))
        full_frame = 3;

    var bw_strict = 0;
    if ($('#bw_list_strict').prop('checked'))
        bw_strict = 1;

    var lpr_text_overlay = 0;
    if ($('#lpr_text_overlay').prop('checked'))
        lpr_text_overlay = 1;

    var frame_rotate = 0;

    frame_rotate = $('#frame_rotate').val();

    var keep_events = 0;
    keep_events = $('#keep_events').val();

    var keep_events_period = 0;
    keep_events_period = $('#keep_events_period').val();

    var direction_angle = direction_vector.getAngle();
    savedDirection.angle = direction_angle;
    direction_angle = Math.floor(direction_angle * 1000);

    var barrier_priority = 0;

    var xml_config = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <roi> \
                            <left>' + left + '</left> \
                            <top>' + top + '</top> \
                            <bottom>' + bottom + '</bottom> \
                            <right>' + right + '</right> \
                            <width>' + roi_width + '</width> \
                            <height>' + roi_height + '</height> \
                            <angle>' + roi_angle + '</angle> \
                        </roi> \
                        <roitwo> \
                            <left>' + left2 + '</left> \
                            <top>' + top2 + '</top> \
                            <bottom>' + bottom2 + '</bottom> \
                            <right>' + right2 + '</right> \
                            <width>' + roi_width2 + '</width> \
                            <height>' + roi_height2 + '</height> \
                            <angle>' + roi_angle2 + '</angle> \
                        </roitwo> \
                        <active_roi>' + active_roi + '</active_roi> \
                        <direction> \
                             <angle>' + direction_angle + '</angle> \
                        </direction> \
                        <plate> \
                        <plate_min_size_percent>' + $(data.min_size_plate).val() + '</plate_min_size_percent> \
                        <plate_min_size>' + $(data.min_size_plate).val() + '</plate_min_size> \
                        <plate_max_size>' + $(data.max_size_plate).val() + '</plate_max_size> \
                        </plate> \
                        <ipc_login>' + $(data.ipc_login).val() + '</ipc_login> \
                        <ipc_password>' + $(data.ipc_pwd).val() + '</ipc_password> \
                        <relay_type>' + $(data.relay_type).val() + '</relay_type> \
                        <relay_port>' + $(data.io_output).val() + '</relay_port> \
                        <barrier_mode>' + $(data.barrier_mode).val() + '</barrier_mode> \
                        <barrier_priority>' + barrier_priority + '</barrier_priority> \
                        <barrier_vehicle_direction>' + $(data.barrier_vehicle_direction).val() + '</barrier_vehicle_direction> \
                        <full_frame>' + full_frame + '</full_frame> \
                        <frame_rotate>' + frame_rotate + '</frame_rotate> \
                        <keep_events>' + keep_events + '</keep_events> \
                        <keep_events_period>' + keep_events_period + '</keep_events_period> \
                        <lprUseCase>' + use_case + '</lprUseCase> \
                        <resolution> \
                            <width>' + width + '</width> \
                            <height>' + height + '</height> \
                        </resolution> \
                        <threshold>' + $(data.threshold).val() + '</threshold> \
                        <bw_strict>' + bw_strict + '</bw_strict> \
                        <bw_ldist>' + $(data.bw_list_ldist).val() + '</bw_ldist> \
                        <lpr_text_overlay>' + lpr_text_overlay + '</lpr_text_overlay> \
                        </configuration>';

    showROI(savedRoi);
    showROI2(savedRoi2);
    //validate lists

    var white_list = $(data.white_list).val();
    var black_list = $(data.black_list).val();

    var arr_wl = white_list.trim().split("\n");
    var arr_bl = black_list.trim().split("\n");


//    arr_bl, arr_wl = checkBWList(arr_bl, arr_wl)


//    document.getElementById('white_list').value = ''
//    document.getElementById('black_list').value = ''

//    var xml_wlist = '<?xml version="1.0" encoding="UTF-8"?> \
//                    <bw_list mode="white">';
    console.log('Black list file:');
    console.log($('#filename_black').text());
    console.log('White list file:');
    console.log($('#filename_white').text());
    var blacklist_fname = $('#filename_black').text();
    var whitelist_fname = $('#filename_white').text();
    showSaveStatus();
    //common config
    savedConfig++;

    if (blacklist_fname)
       savedConfig++;

    if (whitelist_fname)
       savedConfig++;

if (whitelistChanged && !whitelist_fname) {
            whitelist_part_index = 0;
            whitelist_part_counter = 0;
            newWhiteListData =  [];

            var bwpart='';
            var itemscount = 0;

    arr_wl.forEach(function (item, i, arr) {
        if (item != '') {
//            document.getElementById('white_list').value += item + "\n"
//
//            xml_wlist += '<s>' + item + '</s>';


                if ((bwpart.length + item.length) < post_max_buffer)
                {
                    bwpart+=item + '\n';
                }else
                {
                     newWhiteListData[whitelist_part_index] = bwpart;
                     whitelist_part_index++;
                     bwpart = item + '\n';
                }
                itemscount++;
        }
    });

    newWhiteListData[whitelist_part_index] = bwpart;

    whitelist_fname = "white_list_edited";
    savedConfig++;

}

if (blacklistChanged && !blacklist_fname) {
            blacklist_part_index = 0;
            blacklist_part_counter = 0;
            newBlackListData =  [];

            var bwpart='';
            var itemscount = 0;

    arr_bl.forEach(function (item, i, arr) {
        if (item != '') {
//            document.getElementById('white_list').value += item + "\n"
//
//            xml_wlist += '<s>' + item + '</s>';

                if ((bwpart.length + item.length) < post_max_buffer)
                {
                    bwpart+=item + '\n';
                }else
                {
                     newBlackListData[blacklist_part_index] = bwpart;
                     blacklist_part_index++;
                     bwpart = item + '\n';
                }
                itemscount++;
        }
    });

    newBlackListData[blacklist_part_index] = bwpart;

    blacklist_fname = "black_list_edited";
    savedConfig++;

}

/*
    xml_wlist += '</bw_list>';


    var xml_blist = '<?xml version="1.0" encoding="UTF-8"?> \
                    <bw_list mode="black">';

    arr_bl.forEach(function (item, i, arr) {
        if (item != '') {
            document.getElementById('black_list').value += item + "\n"
            xml_blist += '<s>' + item + '</s>';
        }
    });


    xml_blist += '</bw_list>';
*/


    $.ajax({
        type: 'POST',
        url: api_host + "config.cgi",
        contentType: "text/xml",
        processData: false,
        data: xml_config,
        success: function (data) {
                savedConfig--;
//                if (savedConfig == 0)
//                    loadConfig();
        }

    });

/*
    $.ajax({
        type: 'POST',
        url: api_host + "white_list.cgi",
        contentType: "text/xml",
        processData: false,
        data: xml_wlist
    });

    $.ajax({
        type: 'POST',
        url: api_host + "black_list.cgi",
        contentType: "text/xml",
        processData: false,
        data: xml_blist
    });
*/
    //console.log("success");

    if (blacklist_fname)
    {
        var  data="command=new&list=black";
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                uploadblacklist();
            }

        });
    }

    if (whitelist_fname)
    {
        var  data="command=new&list=white";
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                uploadwhitelist();
            }

        });
    }

    $('#success_config').show(300);

    var intervalID = setInterval(function () {
        if (savedConfig == 0){
            loadConfig();
            loadWhitelist();
            loadBlacklist();
             $('#success_config').hide();
             clearInterval(intervalID);
             hideSaveStatus();
        }
    }, 1000);

    return false;
}
function blacklist_finish()
{
        var  data="command=save&list=black";
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                console.log('Black list Uploaded & Saved');
                savedConfig--;
                $('#filename_black').text("");

            }

        });

}
var blacklist_upload = function(index)
{

        var  data="command=upload&list=black&data="+newBlackListData[index];
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                index++;
                if (newBlackListData[index] != undefined)
                   blacklist_upload(index);
                else
                   blacklist_finish();
            }

        });
}

function uploadblacklist()
{
    console.log('Black list start upload:');
    var upload_index = 0;
    blacklist_upload(upload_index);
}

function whitelist_finish()
{
        var  data="command=save&list=white";
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                console.log('White list Uploaded & Saved');
                savedConfig--;
                $('#filename_white').text("");
            }

        });

}
var whitelist_upload = function(index)
{

        var  data="command=upload&list=white&data="+newWhiteListData[index];
        $.ajax({
            type: 'POST',
            url: api_host + "upload.cgi",
            contentType: "text/xml",
            data: data,
            contentType: "application/x-www-form-urlencoded",
            processData: false,
            success: function (data) {
                index++;
                if (newWhiteListData[index] != undefined)
                   whitelist_upload(index);
                else
                   whitelist_finish();
            }

        });
}

function uploadwhitelist()
{
    console.log('white list start upload:');
    var whitelist_upload_index = 0;
    whitelist_upload(whitelist_upload_index);
}

function loadConfigNok() {
    $.ajax({
        url: api_host + 'config_nok.cgi',
        success: function (data) {

            var auth = "";
            if (data.getElementsByTagName("auth")[0].childNodes[0]) {
                auth = data.getElementsByTagName("auth")[0].childNodes[0].nodeValue;
            }
            var numberok_enabled = data.getElementsByTagName("enabled")[0].childNodes[0].nodeValue;
            document.forms['numberok_form'].elements['numberok_data'].value = auth;
            if (numberok_enabled == 'true')
                document.forms['numberok_form'].elements['numberok_enabled'].checked = true;
            else
                document.forms['numberok_form'].elements['numberok_enabled'].checked = false;

        },
        error: function (data) {
        }
    });
};

function setSelectListIndex(s, v) {
    for (var i = 0; i < s.options.length; i++) {
        if (s.options[i].value == v) {
            s.options[i].selected = true;
            return;
        }
    }
}

function loadConfigA1001() {

    var scontroller;
    var sidpoint;
    var selectListAc = "<select name='a1001_controller'>";
    selectListAc += '<option value="">' + "Please Select" + "</option>";
    var selectListIdp = "<select name='a1001_idpoint'>";
    selectListIdp += '<option value="">' + "Please Select" + "</option>";


    $.ajax({
        url: api_host + 'config_axisa1001.cgi',
        success: function (data) {

            var aip = "";
            if (data.getElementsByTagName("ip")[0].childNodes[0])
                aip = data.getElementsByTagName("ip")[0].childNodes[0].nodeValue;

            var alogin = "";
            if (data.getElementsByTagName("login")[0].childNodes[0])
                alogin = data.getElementsByTagName("login")[0].childNodes[0].nodeValue;

            var apassword = "";
            if (data.getElementsByTagName("password")[0].childNodes[0])
                apassword = data.getElementsByTagName("password")[0].childNodes[0].nodeValue;

            var acontroller = "";
            if (data.getElementsByTagName("controller")[0].childNodes[0])
                acontroller = data.getElementsByTagName("controller")[0].childNodes[0].nodeValue;

            var aidpoint = "";
            if (data.getElementsByTagName("idpoint")[0].childNodes[0])
                aidpoint = data.getElementsByTagName("idpoint")[0].childNodes[0].nodeValue;

            var aenabled = data.getElementsByTagName("enabled")[0].childNodes[0].nodeValue;

            document.forms['axisa1001_form'].elements['a1001_ip'].value = aip
            document.forms['axisa1001_form'].elements['a1001_login'].value = alogin;
            document.forms['axisa1001_form'].elements['a1001_pwd'].value = apassword;

            if (aenabled == 'true')
                $("#a1001_enabled").prop("checked", true);
            else
                $("#a1001_enabled").prop("checked", false);

            sidpoint = aidpoint;
            scontroller = acontroller;

            $.ajax({
                type: 'GET',
                dataType: 'text',
                url: api_host + "config_nok_dis.cgi",
                success: function (data) {
                    var jsonData = $.parseJSON(data);
                    for (i = 0; i < jsonData.AccessController.length; i++) {
                        var AccessController = jsonData.AccessController[i];
                        selectListAc += '<option value="' + AccessController.token + '"' + "" + '>' + AccessController.Name + '</option>';
                        if (connecting_a1001 == 1) {
                            document.getElementById("a1001_log").value = 'Found Controller: ' + AccessController.Name;
                        }
                    }
                    selectListAc += "</select>";
                    $('#a1001_controller').html(selectListAc);
                    var selectedanswer = document.getElementById("a1001_controller");
                    setSelectListIndex(selectedanswer, scontroller);
                },
                error: function (data) {
                    if (connecting_a1001 == 1) {
                        document.getElementById("a1001_log").value = 'Request failed';
                    }
                    alert('Loading AccessController config failed');
                    selectListAc += "</select>";
                    $('#a1001_controller').html(selectListAc);
                }
            });

            $.ajax({
                type: 'GET',
                dataType: 'text',
                url: api_host + "config_nok_ena.cgi",
                success: function (data) {
                    var jsonData = $.parseJSON(data);
                    for (i = 0; i < jsonData.IdPoint.length; i++) {
                        var idpoint = jsonData.IdPoint[i];
                        selectListIdp += '<option value="' + idpoint.token + '"' + "" + '>' + idpoint.Name + '</option>';
                    }
                    selectListIdp += "</select>";
                    $('#a1001_idpoint').html(selectListIdp);
                    var selectedanswer = document.getElementById("a1001_idpoint");
                    setSelectListIndex(selectedanswer, sidpoint);
                },
                error: function (data) {
                    alert('Loading IdPoint config failed');
                    selectListIdp += "</select>";
                    $('#a1001_idpoint').html(selectListIdp);
                }
            });

        },
        error: function (data) {

        }
    });


};


/*
 * Save Config
 */
function saveConfigNOK(data) {

    var number_ok_auth = $(data.numberok_data).val();
    var number_ok_enabled = $('#numberok_enabled').prop('checked');

    var number_ok_data = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <auth>' + number_ok_auth + '</auth> \
                        <enabled>' + number_ok_enabled + '</enabled> \
                      </configuration>';

    $.ajax({
        type: 'POST',
        url: api_host + "config_nok.cgi",
        contentType: "text/xml",
        processData: false,
        data: number_ok_data
    });

    $('#success_nok_config').show(300);

    var intervalID = setInterval(function () {
        $('#success_nok_config').hide();
        clearInterval(intervalID);
    }, 5000);


    return false;
}

function testLPRA1001res() {
    $.ajax({
        type: 'GET',
        url: api_host + "test_axisa1001.cgi",
        dataType: 'text',
        processData: false,

        success: function (data) {
            var jsonData = $.parseJSON(data);
            document.getElementById("a1001_log").value += '\r\n' + data;
            alert('Test Ok Result = [' + jsonData.AccessGranted + '] Reason[' + jsonData.Reason + ']');

        },
        error: function (data) {
            alert('Test Fail [Request failed]');
        }

    });

}

function testLPRA1001(data) {

    var test_lpr_str = $(data.test_lpr).val();

    var test_ok_data = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <test>' + test_lpr_str + '</test> \
                      </configuration>';

    $.ajax({
        type: 'POST',
        url: api_host + "test_axisa1001.cgi",
        contentType: "text/xml",
        processData: false,
        data: test_ok_data,

        success: function (data) {
            testLPRA1001res();
        },
        error: function (data) {
            testLPRA1001res();

        }

    });


    return false;
}

function testConnect() {
    $.ajax({
        type: 'GET',
        url: api_host + "test_connect.cgi",
        dataType: 'text',
        processData: false,

        success: function (data) {
            var jsonData = $.parseJSON(data);
            alert('Test Result = [' + jsonData.ConnectResult + ']');
        },
        error: function (data) {
            alert('Test Fail [Request failed]');
        }

    });

}

function testA91xxConf() {

    var test_connect_str = $("#a91xx_url").val();

    var test_ok_data = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <test>' + test_connect_str + '</test> \
                      </configuration>';

    $.ajax({
        type: 'POST',
        url: api_host + "test_connect.cgi",
        contentType: "text/xml",
        processData: false,
        data: test_ok_data,

        success: function (data) {
            testConnect();
        },
        error: function (data) {
            testConnect();

        }

    });

}


function saveConfigA1001Connect(data) {

    var a1001_controller = $("#a1001_controller").val();
    var a1001_idpoint = $("#a1001_idpoint").val();

    if (a1001_idpoint == null) a1001_idpoint = "";
    if (a1001_controller == null) a1001_controller = ""
    var a1001_data = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <ip>' + $(data.a1001_ip).val() + '</ip> \
                        <login>' + $(data.a1001_login).val() + '</login> \
                        <password>' + $(data.a1001_pwd).val() + '</password> \
                        <controller>' + a1001_controller + '</controller> \
                        <idpoint>' + a1001_idpoint + '</idpoint> \
                        <enabled>false</enabled> \
                        </configuration>';

    $.ajax({
        type: 'POST',
        url: api_host + "config_axisa1001conn.cgi",
        contentType: "text/xml",
        processData: false,
        data: a1001_data,

        success: function (data) {
            connecting_a1001 = 1;
            loadConfigA1001();
        },
        error: function (data) {
            alert('A1001 connect Error ');
        }

    });

    $('#success_a1001_config').show(300);

    var intervalID = setInterval(function () {
        $('#success_a1001_config').hide();
        clearInterval(intervalID);
    }, 5000);

    $("#a1001_enabled").prop("checked", false);

    return false;
}


/*
 * Save Config
 */
function saveConfigA1001(data) {

    var a1001_ena = $('#a1001_enabled').prop('checked');
    var a1001_controller = $("#a1001_controller").val();
    var a1001_idpoint = $("#a1001_idpoint").val();

    var a1001_ip = document.forms['axisa1001_form'].elements['a1001_ip'].value;
    var a1001_login = document.forms['axisa1001_form'].elements['a1001_login'].value;
    var a1001_pwd = document.forms['axisa1001_form'].elements['a1001_pwd'].value;

    var a1001_data = '<?xml version="1.0" encoding="UTF-8"?> \
                      <configuration> \
                        <ip>' + a1001_ip + '</ip> \
                        <login>' + a1001_login + '</login> \
                        <password>' + a1001_pwd + '</password> \
                        <controller>' + a1001_controller + '</controller> \
                        <idpoint>' + a1001_idpoint + '</idpoint> \
                        <enabled>' + a1001_ena + '</enabled> \
                        </configuration>';

    $.ajax({
        type: 'POST',
        url: api_host + "config_axisa1001.cgi",
        contentType: "text/xml",
        processData: false,
        data: a1001_data

    });

    $('#success_a1001_config_save').show(300);

    var intervalID = setInterval(function () {
        $('#success_a1001_config_save').hide();
        clearInterval(intervalID);
    }, 5000);


    return false;
}

/*
 * Load cloudConfig()
 */
function loadCloudConfig() {
    jQuery.ajax({
        url: api_host + 'cloud.cgi',
        type: 'GET',
        dataType: 'text'
    })
        .done(function (data) {
            console.log("success");
            console.log("response data : " + data);
            cloudSettings.serverUrl = jQuery(data).find('cloud_url').text();
            cloudSettings.event_protocol = jQuery(data).find('protocol').text();
            cloudSettings.geoLat = jQuery(data).find('latitude').text();
            cloudSettings.geoLon = jQuery(data).find('longtitude').text();
            cloudSettings.sensorProviderId = jQuery(data).find('sensorProviderID').text();
            cloudSettings.event_new = jQuery(data).find('event_new').text() === 'true';
            cloudSettings.event_update = jQuery(data).find('event_update').text() === 'true';
            cloudSettings.event_lost = jQuery(data).find('event_lost').text() === 'true';
            cloudSettings.disableSendingImage = jQuery(data).find('skip_image_in_post').text() === 'true';
            cloudSettings.enableSending = jQuery(data).find('enable').text() === 'true';
            jQuery('#cur_cloud_server').text(cloudSettings.serverUrl);
            jQuery('#cur_geo_lat').text(cloudSettings.geoLat);
            jQuery('#cur_geo_lon').text(cloudSettings.geoLon);
            jQuery('#cur_sensor_provider').text(cloudSettings.sensorProviderId);
            jQuery('#to_send').prop('checked', cloudSettings.enableSending);
            if (cloudSettings.event_protocol == 0)
                jQuery('#cur_event_protocol').text("TCP");
            if (cloudSettings.event_protocol == 1)
                jQuery('#cur_event_protocol').text("HTTP POST");
            jQuery('#send_event_new').prop('checked', cloudSettings.event_new);
            jQuery('#send_event_update').prop('checked', cloudSettings.event_update);
            jQuery('#send_event_lost').prop('checked', cloudSettings.event_lost);
            jQuery('#skip_image_in_post').prop('checked', cloudSettings.disableSendingImage);
            jQuery('#cloud_server').val(cloudSettings.serverUrl);
            jQuery('#geo_lat').val(cloudSettings.geoLat);
            jQuery('#geo_lon').val(cloudSettings.geoLon);
            jQuery('#sensor_provider').val(cloudSettings.sensorProviderId);
            jQuery('#event_protocol').val(cloudSettings.event_protocol);

        })
        .fail(function () {
            console.log("data : ")
            console.log("error");
        })
}

/*
 * Save FF-cloud configuration
 */
function saveCloudConf() {
    var cloudURL = jQuery("#cloud_server").val();
    var geoLat = jQuery("#geo_lat").val();
    var geoLon = jQuery("#geo_lon").val();
    var toSend = jQuery("#to_send").prop("checked");
    var skip_image_in_post = jQuery("#skip_image_in_post").prop("checked");
    var sensor = jQuery("#sensor_provider").val();
    var event_protocol = jQuery("#event_protocol").val();
    var send_event_new =    jQuery("#send_event_new").prop("checked");
    var send_event_update = jQuery("#send_event_update").prop("checked");
    var send_event_lost =   jQuery("#send_event_lost").prop("checked");

    var xml_cloud = '<?xml version="1.0" encoding="UTF-8"?> \
                    <cloud_config> \
                        <cloud_url>' + cloudURL + '</cloud_url> \
                        <latitude>' + geoLat + '</latitude> \
                        <longtitude>' + geoLon + '</longtitude> \
                        <sensorProviderID>' + sensor + '</sensorProviderID> \
                        <protocol>' + event_protocol + '</protocol> \
                        <event_new>' + send_event_new + '</event_new> \
                        <event_update>' + send_event_update + '</event_update> \
                        <event_lost>' + send_event_lost + '</event_lost> \
                        <skip_image_in_post>' + skip_image_in_post + '</skip_image_in_post> \
                        <enable>' + toSend + '</enable> \
                    </cloud_config>';
    jQuery.ajax({
        type: 'POST',
        url: api_host + "cloud.cgi",
        contentType: "text/xml",
        processData: false,
        data: xml_cloud
    })
        .done(function () {
            console.log("success");
            jQuery("#cur_cloud_server").text(cloudURL);
            jQuery("#cur_geo_lat").text(geoLat);
            jQuery("#cur_geo_lon").text(geoLon);
            jQuery("#to_send").prop("checked", toSend);
            jQuery("#skip_image_in_post").prop("checked", skip_image_in_post);
            jQuery("#cur_sensor_provider").text(sensor);
            if (event_protocol == 0)
                jQuery('#cur_event_protocol').text("TCP");
            if (event_protocol == 1)
                jQuery('#cur_event_protocol').text("HTTP POST");
        })
        .fail(function () {
            console.log("error");
        })
        .always(function () {
            console.log("complete");
        });
    console.log("xml_cloud : " + xml_cloud);
}

/*
 * Load A91xx Config()
 */
function loadA91xxConfig() {
    jQuery.ajax({
        url: api_host + 'config_a91xx.cgi',
        type: 'GET',
        dataType: 'text'
    })
        .done(function (data) {
            console.log("success");
            console.log("response data : " + data);
            a91xxSettings.serverUrl = jQuery(data).find('a91xx_url').text();
            a91xxSettings.ipc_login = jQuery(data).find('ipc_login').text();
            a91xxSettings.ipc_password = jQuery(data).find('ipc_password').text();
            a91xxSettings.enableSending = jQuery(data).find('enable').text() === 'true';

            jQuery('#a91xx_url').val(a91xxSettings.serverUrl);
            jQuery('#a91xx_login').val(a91xxSettings.ipc_login);
            jQuery('#a91xx_password').val(a91xxSettings.ipc_password);
            jQuery('#a91xx_to_send').prop('checked', a91xxSettings.enableSending);

        })
        .fail(function () {
            console.log("data : ")
            console.log("error");
        })
}

/*
 * Save A91xx configuration
 */
function saveA91xxConf() {
    var a91xx_url = jQuery("#a91xx_url").val();
    var a91xx_login = jQuery("#a91xx_login").val();
    var a91xx_password = jQuery("#a91xx_password").val();
    var toSend = jQuery("#a91xx_to_send").prop("checked");
    var xml_cloud = '<?xml version="1.0" encoding="UTF-8"?> \
                    <a91xx_config> \
                        <a91xx_url>' + a91xx_url + '</a91xx_url> \
                        <ipc_login>' + a91xx_login + '</ipc_login> \
                        <ipc_password>' + a91xx_password + '</ipc_password> \
                        <enable>' + toSend + '</enable> \
                    </a91xx_config>';
    jQuery.ajax({
        type: 'POST',
        url: api_host + "config_a91xx.cgi",
        contentType: "text/xml",
        processData: false,
        data: xml_cloud
    })
        .done(function () {
            console.log("success");
            jQuery("#cur_a91xx_url").text(a91xx_url);
            jQuery("#cur_a91xx_login").text(a91xx_login);
            jQuery("#cur_a91xx_password").text(a91xx_password);
            jQuery("#a91xx_to_send").prop("checked", toSend);

        })
        .fail(function () {
            console.log("error");
        })
        .always(function () {
            console.log("complete");
        });
    console.log("xml_cloud : " + xml_cloud);
}
function updateBWlistTitle(list,newtitle)
{
}
var whitelistChanged = 0;
var blacklistChanged = 0;

function blacklistonChange(){
    blacklistChanged = 1;
    console.log("Blacklist changed and need to be saved");
}
function whitelistonChange(){
    whitelistChanged = 1;
    console.log("Whitelist changed and need to be saved");
}

/*
 * Load White List
 */
function loadWhitelist() {
    $.ajax({
        url: api_host + 'white_list.cgi',
        success: function (data) {

            var index = 0;
            var res = '';

            while (typeof data.getElementsByTagName("s")[index] != 'undefined') {
                var plate = data.getElementsByTagName("s")[index].childNodes[0].nodeValue;

                plate = plate.replace('\r\n', ' ');
                plate = plate.replace('\n', ' ');
                plate = plate.trim();

                res += plate + '\n';

                index++;
            }

            $('#white_list').val(res);
            $('#whitelist_title').text('White list ('+index+' items)');
            loading_settings++;
            showSettings();
            whitelistChanged = 0;
            //document.getElementById("white_list").readOnly = true;
        },
        error: function (data) {

        }
    });
}


/* 
 * Load Black List
 */
function loadBlacklist() {
    $.ajax({
        url: api_host + 'black_list.cgi',
        success: function (data) {

            var index = 0;
            var res = '';

            while (typeof data.getElementsByTagName("s")[index] != 'undefined') {
                var plate = data.getElementsByTagName("s")[index].childNodes[0].nodeValue;
                plate = plate.replace('\r\n', ' ');
                plate = plate.replace('\n', ' ');
                plate = plate.trim();
                res += plate + '\n';

                index++;
            }

            $('#black_list').val(res);
            $('#blacklist_title').text('Black list ('+index+' items)');

            loading_settings++;
            showSettings();
            //document.getElementById("black_list").readOnly = true;
            blacklistChanged = 0;

        },
        error: function (data) {

        }
    });
}

function processExportEvent(allText) {

    var r = new Array(), j = 0;
    r[++j] = 'date,plate,country,barrier,roi,direction\r\n';

    $(allText).find("event").each(function () {
        var ROI_BMP = $('ROI_BMP', this).text();
        var LPR = $('LPR_UTF8', this).text();
        var LP_BMP = $('LP_BMP', this).text();
        var ACTION = $('ACTION', this).text();
        var COUNTRY = $('COUNTRY', this).text();
        var RTIME = $('RTIME', this).text();
        var ACT_PARAM = $('ACT_PARAM', this).text().charAt(0);
        var TS = $('TS', this).text();
        var ZONE = $('ROI_ID', this).text();
        var DIR = $('DIRECTION', this).text();

        if (searchPagesTimestampTo == -1) {
            searchPagesTimestampTo = TS;
        }
        var MOD_TS = $.trim($('MOD_TS', this).text());
        var n = MOD_TS.lastIndexOf(" ");
        MOD_TS = MOD_TS.substr(0, n);
        r[++j] = MOD_TS;
        r[++j] = ',';

        r[++j] = LPR;
        r[++j] = ',';

        r[++j] = COUNTRY;
        r[++j] = ',';

        if (ACTION < 0) {
            r[++j] = 'No action';
        } else {
            r[++j] = array_action[ACTION];
        }
        r[++j] = ',';

        r[++j] = ZONE;
        r[++j] = ',';

        r[++j] = array_direction[DIR];
        r[++j] = '\r\n';

    });

    return r.join('');
}

function saveSearchResults(lastSearchResult) {

    var d = new Date();
    var sep = "_";
    var filename = "search_results_" + d.getDate() + sep + (parseInt(d.getMonth()) + 1) + sep + d.getFullYear() + sep + d.getHours() + ":" + d.getMinutes() + ".csv";
    var blob = new Blob([lastSearchResult], {type: 'text/csv'});
    if (window.navigator.msSaveOrOpenBlob) {
        window.navigator.msSaveBlob(blob, filename);
    }
    else {
        var elem = window.document.createElement('a');
        elem.href = window.URL.createObjectURL(blob);
        elem.download = filename;
        document.body.appendChild(elem);
        elem.click();
        document.body.removeChild(elem);
    }
}

function saveExportResults(exportedData,list) {

    var d = new Date();
    var sep = "_";
    var filename;
    if (list == "black")
        filename = "blacklist_" + d.getDate() + sep + (parseInt(d.getMonth()) + 1) + sep + d.getFullYear() + sep + d.getHours() + ":" + d.getMinutes() + ".csv";
    else
        filename = "whitelist_" + d.getDate() + sep + (parseInt(d.getMonth()) + 1) + sep + d.getFullYear() + sep + d.getHours() + ":" + d.getMinutes() + ".csv";

    var blob = new Blob([exportedData], {type: 'text/csv'});
    if (window.navigator.msSaveOrOpenBlob) {
        window.navigator.msSaveBlob(blob, filename);
    }
    else {
        var elem = window.document.createElement('a');
        elem.href = window.URL.createObjectURL(blob);
        elem.download = filename;
        document.body.appendChild(elem);
        elem.click();
        document.body.removeChild(elem);
    }
}

function exportSearchEvents() {

    var data = "date,plate,country,barrier,roi,direction";

    if (lastSearchExist) {

        $.ajax({
            type: 'GET',
            url: api_host + 'search.cgi',
            contentType: "text/xml",
            data: save_search_data,
            success: function (data) {
                saveSearchResults(processExportEvent(data));
            }
        });


    } else {
        saveSearchResults(data);
    }
}
function processExportListEvent(allText) {

    var r = new Array(), j = 0;
    //add header

    //r[++j] = 'plate,description\r\n';

    r[++j] = allText;

    return r.join('');
}

function exportListBlack() {

        $.ajax({
            type: 'GET',
            url: api_host + 'api.cgi?api=exportblack',
            contentType: "text/csv",
            processData: false,
            success: function (data) {
                saveExportResults(processExportListEvent(data),"black");
            }
        });

}

function exportListWhite() {

        $.ajax({
            type: 'GET',
            url: api_host + 'api.cgi?api=exportwhite',
            contentType: "text/csv",
            processData: false,
            success: function (data) {
                saveExportResults(processExportListEvent(data),"white");
            }
        });

}

/*
 * Get current datetime
 */
function getCurrentDatetime() {
    var now = new Date();
    var dd = now.getDate();
    var mm = now.getMonth() + 1;
    var yyyy = now.getFullYear();
    var min = now.getMinutes();
    var hour = now.getHours();
    if (dd < 10) {
        dd = '0' + dd;
    }
    if (mm < 10) {
        mm = '0' + mm;
    }
    if (min < 10) {
        min = '0' + min;
    }
    if (hour < 10) {
        hour = '0' + hour;
    }
    now = yyyy + '/' + mm + '/' + dd + ' ' + hour + ':' + min;
    return now;
}

/*
 * String to Timestamp
 */
function toTimestampUTC(strDate) {

    var m_data = new Date(strDate);
    var mill = m_data.getTime() - (m_data.getTimezoneOffset() * 60000);

    console.log("Date " + strDate + "  > " + m_data.getTime() + " > UTC : " + mill);

    return mill / 1000;

}

/*
 * String to Timestamp
 */
function toTimestampCameraSeconds(strDate) {

    var m_date = new Date(strDate);
    var now = new Date();

    /* What for to do this stuff? new Date strDate already returns GMT +00*/
    var timeStamp = m_date.getTime()/* +  now.getTimezoneOffset() * 60000*/;
    if (isNaN(timeStamp)) {
        console.log("toTimestampCameraSeconds : NAN passed");
        return timeStamp;
    }

    timeStamp = timeStamp / 1000;
    console.log("converted " + strDate + " to UTC " + timeStamp);
    console.log("UTC : " + timeStamp);
    timeStamp -= cameraGmtDiffSeconds;
    console.log("CAM : " + timeStamp);

    return timeStamp;

}

/*
 * Tabs
 */
$('.tabs li').on('click', function () {
    var index_active = $('.tabs li').index(this);
    $('.tabs li, .tabs-content .tabpage').removeClass('active-tab');
    $('.tabs li').eq(index_active).addClass('active-tab');
    $('.tabs-content .tabpage').eq(index_active).addClass('active-tab');
});

//$('.show-events').css('height',height_window);
$('#table-events').css('height', height_window);

$('#tabs_main').tabs();

/* Start DateTimePicker */
$('#s_datetimefrom').datetimepicker();
$('#s_datetimeto').datetimepicker();
$("#s_datetimefrom").keypress(function (event) {
    event.preventDefault();
});
$("#s_datetimeto").keypress(function (event) {
    event.preventDefault();
});

$('#clear_datetimefrom').on('click', function () {
    $('#s_datetimefrom').val('');
});
$('#clear_datetimeto').on('click', function () {
    $('#s_datetimeto').val('');
});

/* Show and hide ROI */
$('#settings_tab').on('click', function () {
    $('.lower-canvas').css('display', 'block');
    loading_settings = 0;
    loadWhitelist();
    loadBlacklist();
    loadConfig();
    showSettings()
});
$('#cloud_tab').on('click', function () {
    loadCloudConfig();
});

$('#events_tab, #search_tab,#numberok_tab,#axisa1001_tab,#cloud_tab,#axisa91xx_tab').on('click', function () {
    $('.lower-canvas').css('display', 'none');
    hideSettings();
});
/* End show and hide ROI */

$('#submit_search').on('click', function () {
    var dNow = new Date();
    searchPagesTimestampTo = -1;
    var milliseconds = dNow.getTime();
    $('#number_page').val(1);
    searchEvents();
    return false;
});

$('#export_search').on('click', function () {

    $(this).attr('disabled', 'disabled');
    setTimeout(function () {
        $('#export_search').removeAttr('disabled');
    }, 3000);

    var dNow = new Date();
    var milliseconds = dNow.getTime();
    setCookie('datetimeto', milliseconds);
    exportSearchEvents();
    return false;
});


$('#search_tab').on('click', function () {
    $('#number_page').val(1);
    $('#s_datetimefrom').val(getCurrentDatetime());
    $('#s_datetimeto').val('');
    $('#s_plate').val('');
    $('#s_action').val('');
    $('#s_country').val('');
    searchEvents();
});

$('#numberok_tab').on('click', function () {
    loadConfigNok();
});

$('#axisa1001_tab').on('click', function () {
    connecting_a1001 = 0;
    loadConfigA1001();
});

$('#axisa91xx_tab').on('click', function () {
    loadA91xxConfig();
});

/*
 * End Tabs
 */

/*
 * Show ROI
 */

var roiActive = false;

function hideROI() {
    roiActive = false;
}

function showROI(roi) {

    roiActive = true;

    canvas_f.clear(true);

    /* ------------- ROI -------------- */
    if (roi['left'] && typeof roi['left'] != undefined) {

        var x1 = roi['left'];
        var y1 = roi['top'];
        var x2 = roi['right'];
        var y2 = roi['bottom'];

        var width = roi['width'];
        var height = roi['height'];
        var angle = roi['angle'];

        var options = {
            top: y1,
            left: x1,
            fill: 'rgba(231, 185, 58, 0.10)',
            width: width,
            height: height,
            angle: angle,
            padding: 0,
            cornerSize: 9,
            rotatingPointOffset: 0,
            hasRotatingPoint: true,
            stroke: '#E7B93A',
            cornerColor: 'white',
            borderColor: '#E7B93A',
            transparentCorners: false,
            strokeWidth: 1,
            typeObject: 1,
            id: 1
        };

        rect = new fabric.Rect(options);
        rect.setControlsVisibility({
            tr: false,
            tl: false,
            bl: false,
            br: false,
            mt: false
        });

        canvas_f.add(rect);


    }
    /* ------------- end ROI -------------- */
}

function showROI2(roi) {

    /* ------------- ROI -------------- */
    if (roi['left'] && typeof roi['left'] != undefined) {

        var x1 = roi['left'];
        var y1 = roi['top'];
        var x2 = roi['right'];
        var y2 = roi['bottom'];

        var width = roi['width'];
        var height = roi['height'];
        var angle = roi['angle'];

        var options = {
            top: y1,
            left: x1,
            fill: 'rgba(231, 185, 58, 0.10)',
            width: width,
            height: height,
            angle: angle,
            padding: 0,
            cornerSize: 9,
            rotatingPointOffset: 0,
            hasRotatingPoint: true,
            stroke: '#E7B93A',
            cornerColor: 'white',
            borderColor: '#E7B93A',
            transparentCorners: false,
            strokeWidth: 1,
            typeObject: 1,
            id: 1
        };

        rect2 = new fabric.Rect(options);
        rect2.setControlsVisibility({
            tr: false,
            tl: false,
            bl: false,
            br: false,
            mt: false
        });

        if (active_roi == 2)
            canvas_f.add(rect2);

        tri = new fabric.Triangle({
            left: 50,
            top: 40,
            strokeWidth: 1,
            width: 40, height: 40,
            stroke: 'black',
            fill: 'green',
            selectable: true,
            originX: 'center'
        });

        tri2 = new fabric.Rect({
            top: 80,
            left: 50,
            width: 20,
            height: 20,
            strokeWidth: 1,
            stroke: 'black',
            fill: 'green',
            selectable: true,
            originX: 'center'
        });

        direction_vector = new fabric.Group([tri, tri2]);
        direction_vector.setAngle(savedDirection.angle);
        direction_vector.setControlsVisibility({
            tr: false,
            br: false,
            bl: false,
            ml: false,
            mt: false,
            mr: false,
            mb: false,
            tl: false,
            mtr: true,
        });
        direction_vector.set({
            transparentCorners: false,
            strokeWidth: 4,
            cornerSize: 10,
            rotatingPointOffset: 2,
            stroke: '#E7B93A',
            cornerColor: 'white',
            borderColor: '#E7B93A',
            lockMovementX: true,
            lockMovementY: true,
            lockScalingX: true,
            lockScalingY: true
        });
        canvas_f.add(direction_vector);
    }
    /* ------------- end ROI -------------- */
}

function textAreaListener(e) {
    if (!( ( e.charCode >= 48 && e.charCode < 58 ) || ( e.charCode >= 65 && e.charCode < 91 ) )) {
        e.preventDefault();
    }
}

function yuv2canvasAutoScale(yuv, width, height, canvas) {

    var canvasCopy = document.createElement("canvas");
    var copyContext = canvasCopy.getContext("2d");

    if (width == 0 || height == 0) return;

    canvasCopy.width = width;
    canvasCopy.height = height;

    output = copyContext.createImageData(width, height);
    outputData = output.data;

    $('.lower-canvas').css('display', 'block');

    yOffset = 0;
    uOffset = width * height;
    vOffset = width * height + (width * height) / 4;
    for (var h = 0; h < height; h++) {
        for (var w = 0; w < width; w++) {
            ypos = w + h * width + yOffset;

            Y = yuv[ypos];

            R = G = B = (Y );

            outputData_pos = w * 4 + width * h * 4;
            outputData[0 + outputData_pos] = R;
            outputData[1 + outputData_pos] = G;
            outputData[2 + outputData_pos] = B;
            outputData[3 + outputData_pos] = 255;
        }
    }

    copyContext.putImageData(output, 0, 0);
    // scale
    context = canvas.getContext("2d");
    context.drawImage(canvasCopy, 0, 0, canvasCopy.width, canvasCopy.height, 0, 0, canvas.width, canvas.height);


}


function yuv2canvas(yuv, width, height, canvas) {

    if (width == 0 || height == 0) return;

    $('.lower-canvas').css('display', 'block');

    context = canvas.getContext("2d");
    output = context.createImageData(width, height);
    outputData = output.data;

    yOffset = 0;
    uOffset = width * height;
    vOffset = width * height + (width * height) / 4;
    for (var h = 0; h < height; h++) {
        for (var w = 0; w < width; w++) {
            ypos = w + h * width + yOffset;

            Y = yuv[ypos];

            R = G = B = (Y );

            outputData_pos = w * 4 + width * h * 4;
            outputData[0 + outputData_pos] = R;
            outputData[1 + outputData_pos] = G;
            outputData[2 + outputData_pos] = B;
            outputData[3 + outputData_pos] = 255;
        }
    }

    context.putImageData(output, 0, 0);
}

function clearPlates() {
    if (roiActive) return;
    canvas_f.clear();
}

function drawPlate(text, x1, y1, w, h) {
    console.log("Drawing " + text + " at " + x1 + "," + y1);
    if (roiActive) return;

    var options = {
        top: y1,
        left: x1,
        fill: 'rgba(0, 0, 0, 0.10)',
        width: w,
        height: h,
        angle: 0,
        padding: 0,
        cornerSize: 8,
        rotatingPointOffset: 8,
        hasRotatingPoint: false,
        stroke: '#10c91f',
        strokeWidth: 1,
        typeObject: 1,
        id: 1
    };

    rect = new fabric.Rect(options);
    rect.setControlsVisibility({
        tr: false,
        tl: false,
        bl: false,
        br: false,
    });

    canvas_f.add(rect);//.setActiveObject(rect);

}

function updateOffline() {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', api_host + 'offline.yuv', true);
    xhr.responseType = 'blob';
    xhr.responseType = "arraybuffer";

    var blobReply;

    xhr.onload = function (e) {
        if (this.status == 200) {
            blobReply = this.response;
            var yuvWidth = 480;
            var yuvHeight = 270;

            var yuv = new Uint8Array(blobReply);

            var t0 = performance.now();
            yuv2canvasAutoScale(yuv, yuvWidth, yuvHeight, canvas_video);
            var t1 = performance.now();
            clearPlates();

        } else {
        }
    };
    xhr.onerror = function (e) {
    }

    xhr.send();
}


function updateVideo() {
    var xhr = new XMLHttpRequest();
    xhr.open('GET', api_host + 'live.yuv', true);
    xhr.responseType = 'blob';
    xhr.responseType = "arraybuffer";

    var blobReply;

    xhr.onload = function (e) {
        if (this.status == 200) {
            blobReply = this.response;
            var yuvWidth = this.getResponseHeader("X-FF-Image-Width");
            var yuvHeight = this.getResponseHeader("X-FF-Image-Height");
            var lastFrameInfo = this.getResponseHeader("X-FF-Frame-Info");

            var yuv = new Uint8Array(blobReply);

            var t0 = performance.now();
            yuv2canvasAutoScale(yuv, yuvWidth, yuvHeight, canvas_video);
            var t1 = performance.now();
            clearPlates();
            $(lastFrameInfo).find("event").each(function () {
                var LPR = $('LPR', this).text();
                var COUNTRY = $('COUNTRY', this).text();
                var X = $('LP_X', this).text();
                var Y = $('LP_Y', this).text();
                var W = $('LP_W', this).text();
                var H = $('LP_H', this).text();
                var scaleX = yuvWidth / canvas_video.width;
                var scaleY = yuvHeight / canvas_video.height;
                drawPlate(LPR, X / scaleX, Y / scaleY, W / scaleX, H / scaleY);
            });


            setTimeout(updateVideo, 200);
        } else {
            updateOffline();
            setTimeout(updateVideo, 3000);
        }
    };
    xhr.onerror = function (e) {
        setTimeout(updateVideo, 200);
    }

    xhr.send();
}

$('#new_white_select').on('change',function () {
    console.log("Reading white list");
    readWhiteList();
});

$('#new_black_select').on('change',function () {
    console.log("Reading black list");
    readBlackList();
});

newBlackList = {};
newWhiteList = {};

function readWhiteList(file)
{
    var textareadata = '';
    var bwpart='';
    console.log("Read file"+file.name);

    whitelist_part_index = 0;
    whitelist_part_counter = 0;
    newWhiteListData =  [];

    var reader = new FileReader();
    reader.onload = function(e) {
        var lines = reader.result.split(/\r?\n/);
        var j = 0;
        var itemscount = 0;
        for(var i  in lines){
            var cline = lines[i];
            if (cline.length)
            {
                var splitted = cline.split(',');

                if (typeof splitted[1] === "undefined")
                   cline = splitted[0].trim();
                else
                   cline = splitted[0].trim()+','+splitted[1].trim();

                //fill textareas with first 10 lines
                if (i < 10)
                {
                    textareadata +=  cline + '\n';
                }

                if ((bwpart.length + cline.length) < post_max_buffer)
                {
                    bwpart+=cline + '\n';
                }else
                {
                     newWhiteListData[whitelist_part_index] = bwpart;
                     whitelist_part_index++;
                     bwpart = cline + '\n';
                }
                itemscount++;
            }
       }

       newWhiteListData[whitelist_part_index] = bwpart;

       $('#white_list').val(textareadata);
       $('#whitelist_title').text('White list (show 10 items of '+itemscount+')');

       console.log(file.name+' Loaded '+(whitelist_part_index+1)+' chunks');
  };
  reader.readAsText(file);
}

var  post_max_buffer = 10*1024;

var blacklist_part_index = 0;
var blacklist_part_counter = 0;
var newBlackListData =  [];

var whitelist_part_index = 0;
var whitelist_part_counter = 0;
var newWhiteListData =  [];

function readBlackList(file)
{
    var textareadata = '';
    var bwpart='';
    console.log("Read file"+file.name);

    blacklist_part_index = 0;
    blacklist_part_counter = 0;
    newBlackListData =  [];

    var reader = new FileReader();
    reader.onload = function(e) {
        var lines = reader.result.split(/\r?\n/);
        var j = 0;
        var itemscount = 0;
        for(var i  in lines){
            var cline = lines[i];
            if (cline.length)
            {
                var splitted = cline.split(',');

                if (typeof splitted[1] === "undefined")
                   cline = splitted[0].trim();
                else
                   cline = splitted[0].trim()+','+splitted[1].trim();

                //fill textareas with first 10 lines
                if (i < 10)
                {
                    textareadata +=  cline + '\n';
                }

                if ((bwpart.length + cline.length) < post_max_buffer)
                {
                    bwpart+=cline + '\n';
                }else
                {
                     newBlackListData[blacklist_part_index] = bwpart;
                     blacklist_part_index++;
                     bwpart = cline + '\n';
                }
                itemscount++;
            }
       }

       newBlackListData[blacklist_part_index] = bwpart;

       $('#black_list').val(textareadata);
       $('#blacklist_title').text('Black list (show 10 items of '+itemscount+')');

       console.log(file.name+' Loaded '+(blacklist_part_index+1)+' chunks');
  };
  reader.readAsText(file);
}


$(function () {

    loadEvents();

    setTimeout(function () {
        // Start
        updateVideo();

    }, 200);

    setInterval(function () {

        if (lEvn == true) {
            loadEvents();
            lEvn = false;
        }

    }, 1000);

});
